Index: /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/field_def.xml
===================================================================
--- /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 7618)
+++ /branches/CNRS/dev_r6270_PISCES_QUOTA/NEMOGCM/CONFIG/SHARED/field_def.xml	(revision 7619)
@@ -789,4 +789,11 @@
        <field id="NH4_E3T"      long_name="NH4 * E3T"                                unit="mmol/m2"  > NH4 * e3t </field >
 
+       <!-- PISCES with ligand parametisation : variables available with key_ligand -->
+       <field id="LGW"          long_name="Weak ligands concentration"                unit="mmol/m3" />
+       <field id="LGW_E3T"      long_name="LGW * E3T"                                 unit="mmol/m2" />
+       <field id="FEP"          long_name="Lithogenic iron concentration"             unit="mmol/m3" />
+       <field id="FEP_E3T"      long_name="FEP * E3T"                                 unit="mmol/m2" />
+
+
        <!-- PISCES with Quota parama -->
        <field id="DON"      long_name="Dissolved organic N Concentration"        unit="mmol/m3" />
@@ -871,4 +878,7 @@
        <field id="SIZEP"       long_name="Mean relative size of picophyto."        unit="-"          grid_ref="grid_T_3D" />
        <field id="SIZED"       long_name="Mean relative size of diatoms"           unit="-"          grid_ref="grid_T_3D" />
+      <field id="QPPMAX"       long_name="Maximum N:P quota in picophyto"         unit="-"          grid_ref="grid_T_3D" />
+       <field id="QPNMAX"       long_name="Maximum N:P quota in nanophyto"         unit="-"          grid_ref="grid_T_3D" />
+       <field id="QPDMAX"       long_name="Maximum N:P quota in diatoms"           unit="-"          grid_ref="grid_T_3D" />
        <field id="Fe2"         long_name="Iron II concentration"                   unit="nmol/L"     grid_ref="grid_T_3D" />
        <field id="Fe3"         long_name="Iron III concentration"                  unit="nmol/L"     grid_ref="grid_T_3D" />
@@ -903,4 +913,20 @@
        <field id="Irondep"     long_name="Iron deposition from dust"               unit="mol/m2/s"                     />
        <field id="Ironsed"     long_name="Iron deposition from sediment"           unit="mol/m2/s"  grid_ref="grid_T_3D"/>
+       <field id="AOU"    long_name="AOU"           unit="mol-L"  grid_ref="grid_T_3D" />
+       <field id="NIT"     long_name="Nitrification rate"         unit="mol-N/m3/s"  grid_ref="grid_T_3D" />
+       <field id="FESCAV"       long_name="Scavenging of Iron"                  unit="nmol-Fe/m3/s"  grid_ref="grid_T_3D" />
+       <field id="FECOLL"      long_name="Colloidal Pumping of FeL"             unit="nmol-FeL/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LGWCOLL"    long_name="Coagulation loss of ligands"           unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LIGREM"   long_name="Remineralisation loss of ligands"           unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LIGPR"   long_name="Photochemical loss of ligands"           unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODR"    long_name="OM remineralisation ligand production rate" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODP"    long_name="phytoplankton ligand production rate" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LDETP"    long_name="Ligand destruction during phytoplankton uptake" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODZ2"    long_name="mesozooplankton ligand production rate" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="LPRODZ"    long_name="microzooplankton ligand production rate" unit="nmol-L/m3/s"  grid_ref="grid_T_3D" />
+       <field id="FEZOO"     long_name="microzooplankton iron recycling rate" unit="nmol-FeL/m3/s"  grid_ref="grid_T_3D" />
+       <field id="FEZOO2"     long_name="mesozooplankton iron recycling rate" unit="nmol-FeL/m3/s"  grid_ref="grid_T_3D" />
+       <field id="REMINF"       long_name="Oxic remineralization suppy of Fe"     unit="mol-Fe/m3/s"  grid_ref="grid_T_3D" />
+       <field id="BACT"       long_name="Bacterial Biomass"                  unit="mmol/m3"  grid_ref="grid_T_3D" />
 
        <!-- PISCES with Kriest parametisation : variables available with key_kriest -->