Index: branches/2016/dev_merge_2016/NEMOGCM/CONFIG/ISOMIP/EXP00/namelist_cfg
===================================================================
--- branches/2016/dev_merge_2016/NEMOGCM/CONFIG/ISOMIP/EXP00/namelist_cfg	(revision 7623)
+++ branches/2016/dev_merge_2016/NEMOGCM/CONFIG/ISOMIP/EXP00/namelist_cfg	(revision 7624)
@@ -209,4 +209,11 @@
    ln_eos80    = .true.          !  = Use EOS80 equation of state
    !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   rn_a0       =  0.2         !  thermal expension coefficient (nn_eos= 1)
+   rn_b0       =  0.          !  saline  expension coefficient (nn_eos= 1)
+   rn_lambda1  =  0.          !  cabbeling coeff in T^2  (=0 for linear eos)
+   rn_lambda2  =  0.          !  cabbeling coeff in S^2  (=0 for linear eos)
+   rn_mu1      =  0.          !  thermobaric coeff. in T (=0 for linear eos)
+   rn_mu2      =  0.          !  thermobaric coeff. in S (=0 for linear eos)
+   rn_nu       =  0.          !  cabbeling coeff in T*S  (=0 for linear eos)
 /
 !-----------------------------------------------------------------------
Index: branches/2016/dev_merge_2016/NEMOGCM/CONFIG/LOCK_EXCHANGE/MY_SRC/zdfini.F90
===================================================================
--- branches/2016/dev_merge_2016/NEMOGCM/CONFIG/LOCK_EXCHANGE/MY_SRC/zdfini.F90	(revision 7623)
+++ branches/2016/dev_merge_2016/NEMOGCM/CONFIG/LOCK_EXCHANGE/MY_SRC/zdfini.F90	(revision 7624)
@@ -1,5 +1,8 @@
 MODULE zdfini
    !!======================================================================
-   !!                      ***  MODULE  zdfini  ***
+   !!                     ***  MODULE zdfini  ***
+   !!
+   !!                     ===  LOCK_EXCHANGE case  ===
+   !!
    !! Ocean physics :   read vertical mixing namelist and check consistancy
    !!======================================================================
Index: branches/2016/dev_merge_2016/NEMOGCM/CONFIG/OVERFLOW/EXP00/namelist_cfg
===================================================================
--- branches/2016/dev_merge_2016/NEMOGCM/CONFIG/OVERFLOW/EXP00/namelist_cfg	(revision 7623)
+++ branches/2016/dev_merge_2016/NEMOGCM/CONFIG/OVERFLOW/EXP00/namelist_cfg	(revision 7624)
@@ -48,4 +48,5 @@
                           !     (also = the frequency of sea-ice & iceberg model call)
   ln_usr      = .true.    !  user defined formulation                  (T => check usrdef_sbc)
+  ln_blk      = .false.   !  Bulk formulation                          (T => fill namsbc_blk )
   nn_ice      = 0         !  =0 no ice boundary condition   
   ln_traqsr   = .false.   !  Light penetration in the ocean            (T => fill namtra_qsr )
@@ -77,10 +78,7 @@
 &nameos        !   ocean physical parameters
 !-----------------------------------------------------------------------
-    nn_eos      =  1     !  type of equation of state and Brunt-Vaisala frequency
-                              !  =-1, TEOS-10
-                              !  = 0, EOS-80
-                              !  = 1, S-EOS   (simplified eos)
-   !                     ! S-EOS coefficients (nn_eos=1):
-   !                          !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
+   ln_teos10   = .false.         !  = Use TEOS-10 equation of state
+   ln_eos80    = .true.          !  = Use EOS80 equation of state
+   !                             !  rd(T,S,Z)*rau0 = -a0*(1+.5*lambda*dT+mu*Z+nu*dS)*dT+b0*dS
    rn_a0       =  0.2         !  thermal expension coefficient (nn_eos= 1)
    rn_b0       =  0.          !  saline  expension coefficient (nn_eos= 1)
Index: branches/2016/dev_merge_2016/NEMOGCM/CONFIG/OVERFLOW/MY_SRC/zdfini.F90
===================================================================
--- branches/2016/dev_merge_2016/NEMOGCM/CONFIG/OVERFLOW/MY_SRC/zdfini.F90	(revision 7623)
+++ branches/2016/dev_merge_2016/NEMOGCM/CONFIG/OVERFLOW/MY_SRC/zdfini.F90	(revision 7624)
@@ -55,5 +55,6 @@
       !!
       NAMELIST/namzdf/ rn_avm0, rn_avt0, nn_avb, nn_havtb, ln_zdfexp, nn_zdfexp,   &
-         &              ln_zdfevd, nn_evdm, rn_avevd, ln_zdfnpc, nn_npc, nn_npcp
+         &              ln_zdfevd, nn_evdm, rn_avevd, ln_zdfnpc, nn_npc, nn_npcp,  &
+         &              ln_zdfqiao
       !!----------------------------------------------------------------------
 