Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7646)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zopt.F90	(revision 7681)
@@ -123,6 +123,4 @@
            DO ji = 1, jpi
               IF( etot(ji,jj,jk) >= zpar100(ji,jj) )   neln(ji,jj) = jk + 1 
-              !                                       ! nb. this is to ensure compatibility with
-              !                                       ! nmld_trc definition in trd_mxl_trc_zint
            END DO
          END DO
Index: trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90	(revision 7646)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/PISCES/P2Z/p2zsms.F90	(revision 7681)
@@ -61,5 +61,4 @@
       END IF
 
-      IF( lk_trdmxl_trc )  CALL trd_mxl_bio( kt )   ! trends: Mixed-layer
       !
       IF ( lwm .AND. kt == nittrc000 ) CALL FLUSH    ( numonp )     ! flush output namelist PISCES
Index: trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdtrc.F90
===================================================================
--- trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdtrc.F90	(revision 7646)
+++ trunk/NEMOGCM/NEMO/TOP_SRC/TRP/trdtrc.F90	(revision 7681)
@@ -22,8 +22,4 @@
    PRIVATE
 
-   INTERFACE trd_trc
-      MODULE PROCEDURE trd_trc_trp, trd_trc_bio
-   END INTERFACE
-
    PUBLIC trd_trc
 
@@ -36,5 +32,5 @@
 CONTAINS
 
-   SUBROUTINE trd_trc_trp( ptrtrd, kjn, ktrd, kt )
+   SUBROUTINE trd_trc( ptrtrd, kjn, ktrd, kt )
       !!----------------------------------------------------------------------
       !!                  ***  ROUTINE trd_trc  ***
@@ -103,21 +99,6 @@
       END IF
 
-   END SUBROUTINE trd_trc_trp
+   END SUBROUTINE trd_trc
 
-   SUBROUTINE trd_trc_bio( ptrbio, ktrd, kt )
-      !!----------------------------------------------------------------------
-      !!                  ***  ROUTINE trd_bio  ***
-      !!----------------------------------------------------------------------
-
-      INTEGER, INTENT( in )  ::   kt                                  ! time step
-      INTEGER, INTENT( in )  ::   ktrd                                ! bio trend index
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout )  ::   ptrbio  ! Bio trend
-      !!----------------------------------------------------------------------
-
-#if defined key_trdmxl_trc  
-      CALL trd_mxl_bio_zint( ptrbio, ktrd ) ! Verticaly integrated biological trends
-#endif
-
-   END SUBROUTINE trd_trc_bio
 #else
    !!----------------------------------------------------------------------
@@ -125,29 +106,18 @@
    !!----------------------------------------------------------------------
 
-   INTERFACE trd_trc
-      MODULE PROCEDURE trd_trc_trp, trd_trc_bio
-   END INTERFACE
+   PUBLIC trd_trc
 
 CONTAINS
 
-   SUBROUTINE trd_trc_trp( ptrtrd, kjn, ktrd, kt )
+   SUBROUTINE trd_trc( ptrtrd, kjn, ktrd, kt )
       INTEGER               , INTENT( in )     ::   kt      ! time step
       INTEGER               , INTENT( in )     ::   kjn     ! tracer index
       INTEGER               , INTENT( in )     ::   ktrd    ! tracer trend index
       REAL, DIMENSION(:,:,:), INTENT( inout )  ::   ptrtrd  ! Temperature or U trend
-      WRITE(*,*) 'trd_trc_trp : You should not have seen this print! error?', ptrtrd(1,1,1)
+      WRITE(*,*) 'trd_trc : You should not have seen this print! error?', ptrtrd(1,1,1)
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', kjn
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', ktrd
       WRITE(*,*) '  "      "      : You should not have seen this print! error?', kt
-   END SUBROUTINE trd_trc_trp
-
-   SUBROUTINE trd_trc_bio( ptrbio, ktrd, kt )
-      INTEGER               , INTENT( in )     ::   kt      ! time step
-      INTEGER               , INTENT( in )     ::   ktrd    ! tracer trend index
-      REAL, DIMENSION(:,:,:), INTENT( inout )  ::   ptrbio  ! Temperature or U trend
-      WRITE(*,*) 'trd_trc_trp : You should not have seen this print! error?', ptrbio(1,1,1)
-      WRITE(*,*) '  "      "      : You should not have seen this print! error?', ktrd
-      WRITE(*,*) '  "      "      : You should not have seen this print! error?', kt
-   END SUBROUTINE trd_trc_bio
+   END SUBROUTINE trd_trc
 
 #endif